/*
*       This is the Raiden cipher source code.
*       This file includes the encoding and decoding routines
*
*       Developed by Javier Polimn and Julio Cesar Hernandez
*       Last update: 06th of Feb, 2009.
*       Implemented by Alexander Myasnikov
*       Web: www.darksoftware.narod.ru
*/


#include <string.h>;

typedef unsigned long u32;


u32 key[4];

void __export __stdcall
crypt (u32 * data)
{

  u32 b0 = data[0];
  u32 b1 = data[1];
  u32 i;
  u32 sk;
  u32 k[4];

  for (i = 0; i != 4; i++)
    k[i] = key[i];


  for (i = 0; i < 16; i++)
    {
      sk = k[i % 4] = ((k[0] + k[1]) + ((k[2] + k[3]) ^ (k[0] << k[2])));
      b0 += ((sk + b1) << 9) ^ ((sk - b1) ^ ((sk + b1) >> 14));
      b1 += ((sk + b0) << 9) ^ ((sk - b0) ^ ((sk + b0) >> 14));
    }

  data[0] = b0;
  data[1] = b1;
}





void __export __stdcall
decrypt (u32 * data)
{
  u32 b0 = data[0];
  u32 b1 = data[1];
  u32 i;
  u32 k[4];
  u32 subkeys[16];

  for (i = 0; i != 4; i++)
    k[i] = key[i];


  for (i = 0; i < 16; i++)
    {
      //Subkeys are calculated
      k[i % 4] = ((k[0] + k[1]) + ((k[2] + k[3]) ^ (k[0] << k[2])));
      subkeys[i] = k[i % 4];
    }
  for (i = 15; i != -1; i--)
    {
      //Process is applied in the inverse order
      b1 -=
	((subkeys[i] + b0) << 9) ^ ((subkeys[i] -
				     b0) ^ ((subkeys[i] + b0) >> 14));
      b0 -=
	((subkeys[i] + b1) << 9) ^ ((subkeys[i] -
				     b1) ^ ((subkeys[i] + b1) >> 14));
    }

  data[0] = b0;
  data[1] = b1;

}


void __stdcall __export
setup (u32 * kp)
{

  u32 i;

  for (i = 0; i != 4; i++)
    key[i] = kp[i];

}

#include <string.h>


typedef unsigned char u8;
typedef unsigned long u32;

u32 __stdcall __export
getblocksize ()
{
  return 64;
}

u32 __stdcall __export
getkeysize ()
{
  return 128;
}

void __stdcall __export
getciphername (u8 * p)
{
  strcpy (p, "Raiden-K128-R16");
}
